using System;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting.Channels.Tcp;


namespace Serveur
{
	/// <summary>
	/// Summary description for Serveur.
	/// </summary>
	public class RemotingServer
	{
		public void Start()
		{
			int canal;
			//Ouvre un canal en mode TCP sur le port '1236'
			canal=1236;
			TcpChannel chnl_1 = new TcpChannel(canal);
			ChannelServices.RegisterChannel(chnl_1,true);
		
			//Publier notre objet CompteurManager
			RemotingConfiguration.RegisterWellKnownServiceType(typeof(CompteurManager), "CompteurManager", WellKnownObjectMode.Singleton);		
		}
	}

	
	public class CompteurManager:MarshalByRefObject,IRemote.ICompteur
	{
		DemarreServeur myclass = new DemarreServeur();
		//C'est cette classe que l'on distribue sur le reseau
		public override object InitializeLifetimeService()
		{
			//Dure de vie de l'objet : pour "toujours"
			return null;
		}
		public void Augmenter(double dMontant) 
		{
			myclass.monCompteur.Augmenter(dMontant);
		}

	}

}
